"""
ALP II - Team
SS 2012
"""
"""
----------------------     4th Homework   (4. Übungsblatt)    -------------------------

Task 1

We have two solutions for this task. The difference between both is in the partition function,
which is the key of the Quicksort-Algorithm.

Our first solution uses the same Partition-Algorithm of the lecture slides and just the lines
where the pivot element is chosen have been changed. 

"""

def quicksort(A):   

    def partition(low, high):
        middle = low + (high-low)//2            # we don't use the classic way to calculate the middle 
                                                # of the subarrays (low + heigh)//2 to avoid integer  
                                                # overflow with very large arrays. This is not a problem
                                                # in Python but in other languages.
        A[low], A[middle] = A[middle], A[low]   # We swap the middle element with the first element
        pivot = A[low]                          # and use this new first element as the pivot
        i = low
        for j in range(low+1,high+1):
            if ( A[j] < pivot ):
                i += 1
                A[i], A[j] = A[j], A[i]
        A[i], A[low] = A[low], A[i]
        return i   

    def qsort(low, high):
        if low<high:
            m = partition(low, high )
            qsort (low, m-1)
            qsort (m+1, high)

    qsort(0, len(A)-1)

"""
Our second solution use the original Partition-Algorithm from Hoare.
In this version of the Partition-Function the indices i and j don't move in the 
same direction as in the first solution, but in the opposite direction.

As long as i<j    
   The index i, which begins at the first position of each subarray, moves to the right
   in a loop looking for the next number smaller than the pivot.
   
   The j index, which begins at the end of the subarray, moves to the left looking for the
   next number bigger than the pivot.
   
   If i<j after both indices had moved, we swap the elements at both positions and continue
   moving, looking for the next smaller and bigger element until j>i.

"""

def qsort_hoare(A):

    def partition(low, high):

        middle = low + (high-low) // 2
        pivot = A[middle]

        i = low
        j = high

        while i <= j:
            while A[i] < pivot:     # look for the first element smaller than pivot
                i += 1
            while A[j] > pivot:     # look for the first element bigger than pivot
                j -= 1
            if i <= j:              # if j is not left from i
                A[i], A[j] = A[j], A[i] # swap the elements
                i += 1
                j -= 1
        return (i,j)                # the middle positions of the new subarrays

    def qsort(low, high):

        if high>low:
            (i,j) = partition(low, high )
            qsort (low, j)
            qsort (i, high)
        else:
            return

    qsort(0, len(A)-1)

"""
Task 1, Question a)
    Both Quicksort-Algorithms are not stable, because they sometimes change the order of keys
    with the same values.

    With the first solution it is easy to show this. We just begin with the following array
    A = [5,2,3,2,0,7,9] after we have chosen the middle element 2 as a pivot
    A changes to [2,2,3,5,0,7,9] and the number 2 of the middle is now at the beginning of
    the array before the number 2 at the second position.

    We can show that our second solution is not stable with the following example: 
    If A = [2,9,3,5,0,3,8] and 5 (middle element) is our pivot
    After the first partition A becomes [2,3,3,0,5,9,8]. The number 3 at the second position was
    originally in the 6th position. We have changed the order of both keys with the same value 3.  

"""

"""
Task 1, Question b)
    We don't need stable sort-Algorithms, when we only need to sort objects only in
    relation of one of his properties.
"""

"""
Task 2
"""

from math import log

def shellsortBubble (A):
    if A==[]:
        return []
    size = len(A)
    if size == 1:
        return
    n = int(log(size,2))       # we use the log function to find the exponent of the first
                               # Mersenne-Number smaller than the size of A
    seg_size = 2**n-1          # we calculate the size of the first segment with the first exponent                            
    mersenne_nums = [seg_size] # and only calculate the Mersenne numbers we need
                   
    for i in range(n,1,-1):
        seg_size = ((seg_size)>>1) # a Mersenne number has the binary form 2**n - 1 = ..000011111111..11
        mersenne_nums.append(seg_size)  
    
    for k in range(len(mersenne_nums)):
          currentSegSize = mersenne_nums[k]
          numOfSegments = size//currentSegSize
          
          for i in range(currentSegSize):
              swap = True
              verPos = 0
              
              while verPos<=(numOfSegments) and swap: # we use a Bubblesort-Algorithm to sort the numbers
                  swap = False                        # on our virtual columns
                  j = i                               # first column position
                  while (j + currentSegSize) < size:
                      if A[j]>A[j+currentSegSize]:
                          A[j], A[j+currentSegSize] = A[j+currentSegSize], A[j]
                          swap = True
                      j = j+currentSegSize
                  verPos += 1


"""
Task 3
"""

def start_mergesort(A):
    B = [0 for i in range(len(A))]
    mergesort(A,B,0,len(A)-1)

def bubblesort_for_mergesort(A,left,right):
    """ This function sorts a subarray of A between the left and right position (inclusive)
        using the bubblesort-Algorithm
    """
    for stop in range(right,left,-1):
          stop = right
          k = left
          swap = True
          while swap and k<stop:
              swap = False
              if A[k] < A[k+1]:
                  A[k], A[k+1] = A[k+1], A[k]
                  k += 1
                  swap = True

def mergesort(A, B, left, right):

    if (right-left)>0:
        middle = (right + left) // 2
        mergesort(A, B, left, middle)
        mergesort(A, B, middle+1, right)
        merge(A, B, left, middle+1, right);
    else:
        bubblesort_for_mergesort(A,left,right)
        

def merge(A, B, left, middle, right):
    """ Merges the sorted subarrays from left to middle and from middle to right together
        in one sorted subarray between left and right. It uses array B as a help array 
    """
    a_pos = left                  # index to move on array A
    last_left = middle-1

    for i in range(left,right+1): # copy the numbers to be merged from A to B
        B[i] = A[i]

    while (left <= last_left) and (middle <= right):

        if B[left] <= B[middle]:
            A[a_pos] = B[left]
            a_pos += 1
            left += 1
        else:
            A[a_pos] = B[middle]
            a_pos += 1
            middle += 1

    while left <= last_left: # copy the last elements of the left side
        A[a_pos] = B[left]
        left += 1
        a_pos += 1

    while middle <= right:   # or copy the last elements of the right side
        A[a_pos] = B[middle]
        middle += 1
        a_pos += 1

"""
Task 4

We define some help functions to make a pragmatic test of the sorting algorithms
"""        

""" Test functions """
    
from random import randint

# Help function           

def isSorted(A):
    """ Test if all numbers of A are sorted in ascending order """
    for i in range(len(A)-1):
        if A[i]>A[i+1]:
            return False
    return True

def gen_numbers(n):
    """ generate an array with n random numbers in the range 0 to 99 """
    return [randint(0,99) for i in range(n)]

def test_list_of_sort_algorithms (test_runs = 1,
                                  n = 10,
                                  sort_functions = [quicksort, qsort_hoare, shellsortBubble, start_mergesort]):
    """ Test a List of sort-Algorithms using the isSorted function in an assert statement """
    print("\n Task 1-4 Sort-Algorithms ")   
    A = gen_numbers(n)
    C = gen_numbers(2)
    D = gen_numbers(1)
        
    for sort in sort_functions:
      
        for i in range(test_runs):
            
            print("\n ", str(sort))
            B = A[:]
            print("input: ", B)
            sort(B)
            print("result:", B)
            assert isSorted(B)

            B = C[:]
            print("input: ", B)
            sort(B)
            print("result:", B)
            assert isSorted(B)

            B = D[:]            
            print("input: ", B)
            sort(B)
            print("result:", B)
            assert isSorted(B)

            B = []
            print("input: ", B)
            sort(B)
            print("result:", B)
            assert isSorted(B)

test_list_of_sort_algorithms()

"""
Task 5
"""

def find_nearest_values(A):
    """ find the two numbers of A with the closest values """
    if len(A)==2:
        return (A[0], A[1])
    if len(A)<2:
        return None
    else:       
        help_array = A[:]
        mergesort(A, help_array, 0, len(A)-1)
        nearest = (A[0], A[1])
        
        min_dif = 0 # to store the current smallest distance in our loop
        for i in range(len(A)-1):
            dif = abs(A[i]-A[i+1])
            if dif < min_dif:
                min_dif = dif
                nearest = (A[i],A[i+1])
        return nearest    


def test_nearest_values():
    print("\n Task 6")
    print("Test of the find_nearest_values function")
    
    A = gen_numbers(10)
    print("input: ", A)
    print(find_nearest_values(A))

    A = gen_numbers(2)
    print("input: ", A)
    print(find_nearest_values(A))

    A = gen_numbers(0)
    print("input: ", A)
    print(find_nearest_values(A))

test_nearest_values()
        
"""
Task 7

A majority element in an array A with n elements, appears at least n//2 + 1 times.
Our solution begins with the first element as a potencial majority element
and just counts repetitions, but each time a different element of the current
element occurs we decrement our counter.
If the counter = 0 we change the potential majority element with this new element
and counter = 1.
"""
def majority (A):
    """ Given an array A of integer numbers, finds the number that occurs a
        majority of the time in the array (if it exists) and returns it.
        If it doesn't exists returns None.
    """

    if A == []:  # there is no majority element in an empty array
        return None

    count = 0
    current = A[0]

    for new_elem in A:
        if new_elem == current:
            count += 1
        else:
            count -= 1
        if count == 0:
            current = new_elem
            count = 1

    """ now the current element is a majority element, if a majority exists
        We need to confirm that the current element is indeed the majority
        element.
        We just need to count the repetitions of the current element
    """
    count = 0

    for elem in A:
        if elem == current:
            count += 1
            
    if count > len(A) / 2:
        return current
   
    return None


def test_majority ():
    def test (A, expected):
        m = majority (A)
        print ("calculated=", m, "expected=", expected, m == expected)

    print("\n Task 7")
    print("Test majority function")
    test ([3, 3, 1, -4, 0, 3, 3, 3, 7, -5, 3, 3, -5, 3, -20, 25, 3], 3)
    test ([2,2,3,2,2,3,2,2,3,2,2,3,2,2,3,2,2,3,2,2,3,2,2,3,3,3,3], 2)
    test ([2,3,2,3,2,3,2,3,2,3,4,4,4,4,4,4], None)
    test ([2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3], None)
    test ([2,2,1,2,3,2,3,2,3], 2)
    test ([1, 2, 3], None)
    test ([], None)
    test ([1], 1)

test_majority ()

"""
Task 8 (8. Aufgabe)  
"""
def find_longest_seq(B):
    """ We use the original function of the lecture slides 
        and only changed the condition of the outer if-statement

        j>max  was changed to  j>max and B[i][j-3:j] == "TAC"
    """
    max = 0

    for i in range(len(B)-1):
        min_len = min(len(B[i]), len(B[i+1]))
        j = 0
        while j < min_len and B[i][j] == B[i+1][j]:
            j += 1
        if j > max and B[i][j-3:j] == "TAC":
            max = j
            if j == min_len:
                seq = B[i][:j+1]
            else:
                seq = B[i][:j]
    return seq


def LRS_Algorithmus(A):
    """ was implemented like in the slides of the lecture but the generate_suffixes
        function can be simplified in Python using the following line of code.
    """
    B = list(A[i:] for i in range(len(A)))
    
    quicksort(B)                # we use our own Sort-Algorithm
    seq = find_longest_seq(B)

    return seq

dna = "AAGAGCAGTGCCTCCTTTGGTGAAGGTGACACATCATGTGACCTCTTCAGTGACCACTCTACGGTGT" \
    + "CGGGCCTTGAACTACTACCCCCAGAAAGAGCAGACATCACCATGAAGTAAGAGCAGGGCTGAAGGA" \
    + "TAAGCAGCCAATGGATGCACAAGGAGTTCGAACCTAAAGACGTATTGCCCAATGGGGATGGGACCT" \
    + "ACCAGGGCTGGATAAAGAGCAGACCTTGGCTGTACCCCCTGGGGAAGAGCAGAGATATACGTACCA" \
    + "GGTGGAGCACCCAGGCCTGGATCAGCCCCTCATTGTGATCTGAAGAAGGG"

def find_longest_repeating_tac_sequence():
    print("\n Task 8")
    print("Find the longest repeating sequence with TAC as suffix")
    print (LRS_Algorithmus (dna))

find_longest_repeating_tac_sequence()
